alter table if exists activity_activity drop constraint if exists FKbgun0t35p2ihcxn8patylh7ei;
alter table if exists activity_activity drop constraint if exists FK856qyqt9mvrfoqfewckota32l;
alter table if exists activity_applications drop constraint if exists FKgpke88w3phwpyfm2gap7gsbqy;
alter table if exists activity_artifact drop constraint if exists FKr2t1bft22426ydaisg7qos1sx;
alter table if exists activity_artifact drop constraint if exists FKm6lgm7vk4gx2bq2t682f5au7m;
alter table if exists activity_event drop constraint if exists FKernro2awbyv2x1xme9xxkpx79;
alter table if exists artifact_applications drop constraint if exists FKnuec7ujr5ki9m9ksdpri6r4aw;
alter table if exists artifact_artifact drop constraint if exists FKl60d413bvu24r4ys4g9ic0csq;
alter table if exists artifact_artifact drop constraint if exists FK251ivm83uhpvsj0rha6b4sd65;
alter table if exists generalprojectprocess drop constraint if exists FKr7kvuji078e9l1fo7ty4iu70p;
alter table if exists generalprojectprocess drop constraint if exists FK1ltamn8bjxdhknf5vwf7rqtch;
alter table if exists general_project_process_applications drop constraint if exists FK1qdlp6r8mihoqxnatlox7asw5;
alter table if exists organization_applications drop constraint if exists FKsobx44co0xcj2ou6ike1vl6cm;
alter table if exists organizational_role_applications drop constraint if exists FKkvw9oao6kvhfifrein3abvvv7;
alter table if exists person_applications drop constraint if exists FKb306omnaupdd9c54spjg928ab;
alter table if exists project drop constraint if exists FK56l08pkdkr9onlugrsj27t6a3;
alter table if exists project drop constraint if exists FK8bibak77woh8739ssogpu62x4;
alter table if exists project_applications drop constraint if exists FK79ms8s6l5dy4q7jxhc48315s3;
alter table if exists projectstakeholder drop constraint if exists FK1aeay33ut5qiab5f14yfgc860;
alter table if exists projectstakeholder drop constraint if exists FKjy09iied3j38jttfw54gvw2th;
alter table if exists project_stakeholder_activity drop constraint if exists FKt8wkrnf52ifyahyc97uqxd0tl;
alter table if exists project_stakeholder_activity drop constraint if exists FKea11gtmc773hanettouf62o3l;
alter table if exists project_stakeholder_artifact drop constraint if exists FKemjjenufh7900sgysrw8lmk44;
alter table if exists project_stakeholder_artifact drop constraint if exists FKkk4perfcvmmwl99ikg0x45hkv;
alter table if exists projectstakeholder_softwareproject drop constraint if exists FKlnoty0i3693rdxqxluqkmhpf5;
alter table if exists projectstakeholder_softwareproject drop constraint if exists FKqmhcno175t96hnr41q1mew2lm;
alter table if exists specificprojectprocess drop constraint if exists FK3el8abvfdvq1eyxxpkalq6n8f;
alter table if exists specificprojectprocess_activity drop constraint if exists FKnpumbcw7tauilyav0mg51cksx;
alter table if exists specificprojectprocess_activity drop constraint if exists FKskgrq5pv82rl5r76qlbkstt9s;
alter table if exists specific_project_process_applications drop constraint if exists FK5oe7q9g7918mjd2m80rlbn6yh;
alter table if exists specificprojectprocess_artifact drop constraint if exists FK46txspuyq3g04uui3w7rolffl;
alter table if exists specificprojectprocess_artifact drop constraint if exists FKdqwc5u6v1cpwrek437phdg2oa;
alter table if exists specificprojectprocess_specificprojectprocess drop constraint if exists FKepwcomab8m3maddhhvedl7rh8;
alter table if exists specificprojectprocess_specificprojectprocess drop constraint if exists FKi28hj6kgufw4l2j5we3brgpet;
alter table if exists team drop constraint if exists FKt2rwhhxcjdmje0gqqybiyjdpn;
alter table if exists team drop constraint if exists FKp6ovpc4soflfcjbafch33w2ky;
alter table if exists team drop constraint if exists FK2br1drpqmglvo69ygcy2ex0qm;
alter table if exists team_applications drop constraint if exists FKg547qov8jsxcd73ctr90cv0vc;
alter table if exists teammembership drop constraint if exists FK32hd3ylrcn09jp4eorylbk0i0;
alter table if exists teammembership drop constraint if exists FK7twk5vq5jggy5821vfsop01ka;
alter table if exists teammembership drop constraint if exists FK143nbxei8pea2oxm87slwgsut;
alter table if exists team_membership_applications drop constraint if exists FKsx913heurcreuiqtwhp3jj33r;
drop table if exists activity cascade;
drop table if exists activity_activity cascade;
drop table if exists activity_applications cascade;
drop table if exists activity_artifact cascade;
drop table if exists activity_event cascade;
drop table if exists artifact cascade;
drop table if exists artifact_applications cascade;
drop table if exists artifact_artifact cascade;
drop table if exists generalprojectprocess cascade;
drop table if exists general_project_process_applications cascade;
drop table if exists organization cascade;
drop table if exists organization_applications cascade;
drop table if exists organizationalrole cascade;
drop table if exists organizational_role_applications cascade;
drop table if exists person cascade;
drop table if exists person_applications cascade;
drop table if exists project cascade;
drop table if exists project_applications cascade;
drop table if exists projectstakeholder cascade;
drop table if exists project_stakeholder_activity cascade;
drop table if exists project_stakeholder_artifact cascade;
drop table if exists projectstakeholder_softwareproject cascade;
drop table if exists specificprojectprocess cascade;
drop table if exists specificprojectprocess_activity cascade;
drop table if exists specific_project_process_applications cascade;
drop table if exists specificprojectprocess_artifact cascade;
drop table if exists specificprojectprocess_specificprojectprocess cascade;
drop table if exists team cascade;
drop table if exists team_applications cascade;
drop table if exists teammembership cascade;
drop table if exists team_membership_applications cascade;
create table activity (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, updated_date timestamp(6), description varchar(255), internal_id varchar(255) unique, name varchar(255), primary key (id));
create table activity_activity (activity_from_id bigint, activity_to_id bigint, created_at timestamp(6), event_date timestamp(6), id bigserial not null, primary key (id));
create table activity_applications (activity_id bigint not null, external_id varchar(255), name varchar(255));
create table activity_artifact (activity_id bigint, artifact_id bigint, created_at timestamp(6), id bigserial not null, actionartifacttype varchar(255) check (actionartifacttype in ('CREATED','USAGE','DELETED','UPDATED')), primary key (id));
create table activity_event (activity bigint, created_at timestamp(6), event_date timestamp(6), id bigserial not null, statetype varchar(255) check (statetype in ('PERFORMED','INTENDED')), successtype varchar(255) check (successtype in ('UNDEFINED','SUCCESSS','UNSUCCESS')), primary key (id));
create table artifact (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, updated_date timestamp(6), artifacttype varchar(255) check (artifacttype in ('SOFTWAREPRODUCT','SOFTWAREITEM','INFORMATIONITEM','DOCUMENT')), description varchar(255), internal_id varchar(255) unique, name varchar(255), primary key (id));
create table artifact_applications (artifact_id bigint not null, external_id varchar(255), name varchar(255));
create table artifact_artifact (artifact_from_id bigint, artifact_to_id bigint, created_at timestamp(6), event_date timestamp(6), id bigserial not null, artifactrelation varchar(255) check (artifactrelation in ('COMPOSED','RELATED')), primary key (id));
create table generalprojectprocess (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), generalprojectprocess_id bigint, id bigserial not null, softwareproject_id bigint unique, updated_date timestamp(6), description varchar(255), internal_id varchar(255) unique, name varchar(255), statetype varchar(255) check (statetype in ('PERFORMED','INTENDED')), successtype varchar(255) check (successtype in ('UNDEFINED','SUCCESSS','UNSUCCESS')), primary key (id));
create table general_project_process_applications (general_project_process_id bigint not null, external_id varchar(255), name varchar(255));
create table organization (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, updated_date timestamp(6), description varchar(255), internal_id varchar(255) unique, name varchar(255), primary key (id));
create table organization_applications (organization_id bigint not null, external_id varchar(255), name varchar(255));
create table organizationalrole (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, updated_date timestamp(6), description varchar(255), internal_id varchar(255) unique, name varchar(255), primary key (id));
create table organizational_role_applications (organizational_role_id bigint not null, external_id varchar(255), name varchar(255));
create table person (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, updated_date timestamp(6), description varchar(255), email varchar(255), internal_id varchar(255) unique, name varchar(255), primary key (id));
create table person_applications (person_id bigint not null, external_id varchar(255), name varchar(255));
create table project (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, organization_id bigint, project_id bigint, updated_date timestamp(6), dtype varchar(31) not null, description varchar(255), internal_id varchar(255) unique, name varchar(255), primary key (id));
create table project_applications (project_id bigint not null, external_id varchar(255), name varchar(255));
-- Person and Team can be unique
create table projectstakeholder (created_at timestamp(6), id bigserial not null, person_id bigint , team_id bigint , dtype varchar(31) not null, primary key (id));
create table project_stakeholder_activity (activity_id bigint, created_at timestamp(6), event_date timestamp(6), id bigserial not null, projectstakeholder_id bigint, participation varchar(255) check (participation in ('PARTICIPATESIN','ISINCHARGEOF')), primary key (id));
create table project_stakeholder_artifact (artifact_id bigint, created_at timestamp(6), id bigserial not null, projectstakeholder_id bigint, primary key (id));
create table projectstakeholder_softwareproject (created_at timestamp(6), id bigserial not null, projectstakeholder_id bigint, softwareproject_id bigint, primary key (id));
create table specificprojectprocess (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), generalprojectprocess_id bigint, id bigserial not null, updated_date timestamp(6), description varchar(255), internal_id varchar(255) unique, name varchar(255), statetype varchar(255) check (statetype in ('PERFORMED','INTENDED')), successtype varchar(255) check (successtype in ('UNDEFINED','SUCCESSS','UNSUCCESS')), primary key (id));
create table specificprojectprocess_activity (activity_id bigint, created_at timestamp(6), event_date timestamp(6), id bigserial not null, specificproject_id bigint, primary key (id));
create table specific_project_process_applications (specific_project_process_id bigint not null, external_id varchar(255), name varchar(255));
create table specificprojectprocess_artifact (artifact_id bigint, created_at timestamp(6), id bigserial not null, specificprojectprocess_id bigint, actionartifacttype varchar(255) check (actionartifacttype in ('CREATED','USAGE','DELETED','UPDATED')), primary key (id));
create table specificprojectprocess_specificprojectprocess (created_at timestamp(6), event_date timestamp(6), id bigserial not null, specificprojectprocess_from_id bigint, specificprojectprocess_to_id bigint, primary key (id));
create table team (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, organization_id bigint, project_id bigint, team_id bigint, updated_date timestamp(6), description varchar(255), internal_id varchar(255) unique, name varchar(255), team_purpose varchar(255), teamtype varchar(255) check (teamtype in ('PROJECTTEAM','ORGANIZATIONALTEAM')), primary key (id));
create table team_applications (team_id bigint not null, external_id varchar(255), name varchar(255));
-- Organization Role, Person and team cant be unique
create table teammembership (end_date date, start_date date, created_at timestamp(6), created_date timestamp(6), id bigserial not null, organizationalrole_id bigint , person_id bigint , team_id bigint , updated_date timestamp(6), description varchar(255), internal_id varchar(255) unique, name varchar(255), primary key (id));
create table team_membership_applications (team_membership_id bigint not null, external_id varchar(255), name varchar(255));
alter table if exists activity_activity add constraint FKbgun0t35p2ihcxn8patylh7ei foreign key (activity_from_id) references activity;
alter table if exists activity_activity add constraint FK856qyqt9mvrfoqfewckota32l foreign key (activity_to_id) references activity;
alter table if exists activity_applications add constraint FKgpke88w3phwpyfm2gap7gsbqy foreign key (activity_id) references activity;
alter table if exists activity_artifact add constraint FKr2t1bft22426ydaisg7qos1sx foreign key (activity_id) references activity;
alter table if exists activity_artifact add constraint FKm6lgm7vk4gx2bq2t682f5au7m foreign key (artifact_id) references artifact;
alter table if exists activity_event add constraint FKernro2awbyv2x1xme9xxkpx79 foreign key (activity) references activity;
alter table if exists artifact_applications add constraint FKnuec7ujr5ki9m9ksdpri6r4aw foreign key (artifact_id) references artifact;
alter table if exists artifact_artifact add constraint FKl60d413bvu24r4ys4g9ic0csq foreign key (artifact_from_id) references artifact;
alter table if exists artifact_artifact add constraint FK251ivm83uhpvsj0rha6b4sd65 foreign key (artifact_to_id) references artifact;
alter table if exists generalprojectprocess add constraint FKr7kvuji078e9l1fo7ty4iu70p foreign key (generalprojectprocess_id) references generalprojectprocess;
alter table if exists generalprojectprocess add constraint FK1ltamn8bjxdhknf5vwf7rqtch foreign key (softwareproject_id) references project;
alter table if exists general_project_process_applications add constraint FK1qdlp6r8mihoqxnatlox7asw5 foreign key (general_project_process_id) references generalprojectprocess;
alter table if exists organization_applications add constraint FKsobx44co0xcj2ou6ike1vl6cm foreign key (organization_id) references organization;
alter table if exists organizational_role_applications add constraint FKkvw9oao6kvhfifrein3abvvv7 foreign key (organizational_role_id) references organizationalrole;
alter table if exists person_applications add constraint FKb306omnaupdd9c54spjg928ab foreign key (person_id) references person;
alter table if exists project add constraint FK56l08pkdkr9onlugrsj27t6a3 foreign key (organization_id) references organization;
alter table if exists project add constraint FK8bibak77woh8739ssogpu62x4 foreign key (project_id) references project;
alter table if exists project_applications add constraint FK79ms8s6l5dy4q7jxhc48315s3 foreign key (project_id) references project;
alter table if exists projectstakeholder add constraint FK1aeay33ut5qiab5f14yfgc860 foreign key (person_id) references person;
alter table if exists projectstakeholder add constraint FKjy09iied3j38jttfw54gvw2th foreign key (team_id) references team;
alter table if exists project_stakeholder_activity add constraint FKt8wkrnf52ifyahyc97uqxd0tl foreign key (activity_id) references activity;
alter table if exists project_stakeholder_activity add constraint FKea11gtmc773hanettouf62o3l foreign key (projectstakeholder_id) references projectstakeholder;
alter table if exists project_stakeholder_artifact add constraint FKemjjenufh7900sgysrw8lmk44 foreign key (artifact_id) references artifact;
alter table if exists project_stakeholder_artifact add constraint FKkk4perfcvmmwl99ikg0x45hkv foreign key (projectstakeholder_id) references projectstakeholder;
alter table if exists projectstakeholder_softwareproject add constraint FKlnoty0i3693rdxqxluqkmhpf5 foreign key (projectstakeholder_id) references projectstakeholder;
alter table if exists projectstakeholder_softwareproject add constraint FKqmhcno175t96hnr41q1mew2lm foreign key (softwareproject_id) references project;
alter table if exists specificprojectprocess add constraint FK3el8abvfdvq1eyxxpkalq6n8f foreign key (generalprojectprocess_id) references generalprojectprocess;
alter table if exists specificprojectprocess_activity add constraint FKnpumbcw7tauilyav0mg51cksx foreign key (activity_id) references activity;
alter table if exists specificprojectprocess_activity add constraint FKskgrq5pv82rl5r76qlbkstt9s foreign key (specificproject_id) references specificprojectprocess;
alter table if exists specific_project_process_applications add constraint FK5oe7q9g7918mjd2m80rlbn6yh foreign key (specific_project_process_id) references specificprojectprocess;
alter table if exists specificprojectprocess_artifact add constraint FK46txspuyq3g04uui3w7rolffl foreign key (artifact_id) references artifact;
alter table if exists specificprojectprocess_artifact add constraint FKdqwc5u6v1cpwrek437phdg2oa foreign key (specificprojectprocess_id) references specificprojectprocess;
alter table if exists specificprojectprocess_specificprojectprocess add constraint FKepwcomab8m3maddhhvedl7rh8 foreign key (specificprojectprocess_from_id) references specificprojectprocess;
alter table if exists specificprojectprocess_specificprojectprocess add constraint FKi28hj6kgufw4l2j5we3brgpet foreign key (specificprojectprocess_to_id) references specificprojectprocess;
alter table if exists team add constraint FKt2rwhhxcjdmje0gqqybiyjdpn foreign key (organization_id) references organization;
alter table if exists team add constraint FKp6ovpc4soflfcjbafch33w2ky foreign key (project_id) references project;
alter table if exists team add constraint FK2br1drpqmglvo69ygcy2ex0qm foreign key (team_id) references team;
alter table if exists team_applications add constraint FKg547qov8jsxcd73ctr90cv0vc foreign key (team_id) references team;
alter table if exists teammembership add constraint FK32hd3ylrcn09jp4eorylbk0i0 foreign key (organizationalrole_id) references organizationalrole;
alter table if exists teammembership add constraint FK7twk5vq5jggy5821vfsop01ka foreign key (person_id) references person;
alter table if exists teammembership add constraint FK143nbxei8pea2oxm87slwgsut foreign key (team_id) references team;
alter table if exists team_membership_applications add constraint FKsx913heurcreuiqtwhp3jj33r foreign key (team_membership_id) references teammembership;
